// ==============================================================
// RTL generated by Vivado(TM) HLS - High-Level Synthesis from C, C++ and SystemC
// Version: 2019.1
// Copyright (C) 1986-2019 Xilinx, Inc. All Rights Reserved.
// 
// ===========================================================

#include "hls_macc.h"
#include "AESL_pkg.h"

using namespace std;

namespace ap_rtl {

const sc_logic hls_macc::ap_const_logic_1 = sc_dt::Log_1;
const sc_logic hls_macc::ap_const_logic_0 = sc_dt::Log_0;
const sc_lv<60> hls_macc::ap_ST_fsm_state1 = "1";
const sc_lv<60> hls_macc::ap_ST_fsm_state2 = "10";
const sc_lv<60> hls_macc::ap_ST_fsm_state3 = "100";
const sc_lv<60> hls_macc::ap_ST_fsm_state4 = "1000";
const sc_lv<60> hls_macc::ap_ST_fsm_state5 = "10000";
const sc_lv<60> hls_macc::ap_ST_fsm_state6 = "100000";
const sc_lv<60> hls_macc::ap_ST_fsm_state7 = "1000000";
const sc_lv<60> hls_macc::ap_ST_fsm_state8 = "10000000";
const sc_lv<60> hls_macc::ap_ST_fsm_state9 = "100000000";
const sc_lv<60> hls_macc::ap_ST_fsm_state10 = "1000000000";
const sc_lv<60> hls_macc::ap_ST_fsm_state11 = "10000000000";
const sc_lv<60> hls_macc::ap_ST_fsm_state12 = "100000000000";
const sc_lv<60> hls_macc::ap_ST_fsm_state13 = "1000000000000";
const sc_lv<60> hls_macc::ap_ST_fsm_state14 = "10000000000000";
const sc_lv<60> hls_macc::ap_ST_fsm_state15 = "100000000000000";
const sc_lv<60> hls_macc::ap_ST_fsm_state16 = "1000000000000000";
const sc_lv<60> hls_macc::ap_ST_fsm_state17 = "10000000000000000";
const sc_lv<60> hls_macc::ap_ST_fsm_state18 = "100000000000000000";
const sc_lv<60> hls_macc::ap_ST_fsm_state19 = "1000000000000000000";
const sc_lv<60> hls_macc::ap_ST_fsm_state20 = "10000000000000000000";
const sc_lv<60> hls_macc::ap_ST_fsm_state21 = "100000000000000000000";
const sc_lv<60> hls_macc::ap_ST_fsm_state22 = "1000000000000000000000";
const sc_lv<60> hls_macc::ap_ST_fsm_state23 = "10000000000000000000000";
const sc_lv<60> hls_macc::ap_ST_fsm_state24 = "100000000000000000000000";
const sc_lv<60> hls_macc::ap_ST_fsm_state25 = "1000000000000000000000000";
const sc_lv<60> hls_macc::ap_ST_fsm_state26 = "10000000000000000000000000";
const sc_lv<60> hls_macc::ap_ST_fsm_state27 = "100000000000000000000000000";
const sc_lv<60> hls_macc::ap_ST_fsm_state28 = "1000000000000000000000000000";
const sc_lv<60> hls_macc::ap_ST_fsm_state29 = "10000000000000000000000000000";
const sc_lv<60> hls_macc::ap_ST_fsm_state30 = "100000000000000000000000000000";
const sc_lv<60> hls_macc::ap_ST_fsm_state31 = "1000000000000000000000000000000";
const sc_lv<60> hls_macc::ap_ST_fsm_state32 = "10000000000000000000000000000000";
const sc_lv<60> hls_macc::ap_ST_fsm_state33 = "100000000000000000000000000000000";
const sc_lv<60> hls_macc::ap_ST_fsm_state34 = "1000000000000000000000000000000000";
const sc_lv<60> hls_macc::ap_ST_fsm_state35 = "10000000000000000000000000000000000";
const sc_lv<60> hls_macc::ap_ST_fsm_state36 = "100000000000000000000000000000000000";
const sc_lv<60> hls_macc::ap_ST_fsm_state37 = "1000000000000000000000000000000000000";
const sc_lv<60> hls_macc::ap_ST_fsm_state38 = "10000000000000000000000000000000000000";
const sc_lv<60> hls_macc::ap_ST_fsm_state39 = "100000000000000000000000000000000000000";
const sc_lv<60> hls_macc::ap_ST_fsm_state40 = "1000000000000000000000000000000000000000";
const sc_lv<60> hls_macc::ap_ST_fsm_state41 = "10000000000000000000000000000000000000000";
const sc_lv<60> hls_macc::ap_ST_fsm_state42 = "100000000000000000000000000000000000000000";
const sc_lv<60> hls_macc::ap_ST_fsm_state43 = "1000000000000000000000000000000000000000000";
const sc_lv<60> hls_macc::ap_ST_fsm_state44 = "10000000000000000000000000000000000000000000";
const sc_lv<60> hls_macc::ap_ST_fsm_state45 = "100000000000000000000000000000000000000000000";
const sc_lv<60> hls_macc::ap_ST_fsm_state46 = "1000000000000000000000000000000000000000000000";
const sc_lv<60> hls_macc::ap_ST_fsm_state47 = "10000000000000000000000000000000000000000000000";
const sc_lv<60> hls_macc::ap_ST_fsm_state48 = "100000000000000000000000000000000000000000000000";
const sc_lv<60> hls_macc::ap_ST_fsm_state49 = "1000000000000000000000000000000000000000000000000";
const sc_lv<60> hls_macc::ap_ST_fsm_state50 = "10000000000000000000000000000000000000000000000000";
const sc_lv<60> hls_macc::ap_ST_fsm_state51 = "100000000000000000000000000000000000000000000000000";
const sc_lv<60> hls_macc::ap_ST_fsm_state52 = "1000000000000000000000000000000000000000000000000000";
const sc_lv<60> hls_macc::ap_ST_fsm_state53 = "10000000000000000000000000000000000000000000000000000";
const sc_lv<60> hls_macc::ap_ST_fsm_state54 = "100000000000000000000000000000000000000000000000000000";
const sc_lv<60> hls_macc::ap_ST_fsm_state55 = "1000000000000000000000000000000000000000000000000000000";
const sc_lv<60> hls_macc::ap_ST_fsm_state56 = "10000000000000000000000000000000000000000000000000000000";
const sc_lv<60> hls_macc::ap_ST_fsm_state57 = "100000000000000000000000000000000000000000000000000000000";
const sc_lv<60> hls_macc::ap_ST_fsm_state58 = "1000000000000000000000000000000000000000000000000000000000";
const sc_lv<60> hls_macc::ap_ST_fsm_state59 = "10000000000000000000000000000000000000000000000000000000000";
const sc_lv<60> hls_macc::ap_ST_fsm_state60 = "100000000000000000000000000000000000000000000000000000000000";
const sc_lv<32> hls_macc::ap_const_lv32_0 = "00000000000000000000000000000000";
const int hls_macc::C_S_AXI_DATA_WIDTH = "100000";
const sc_lv<32> hls_macc::ap_const_lv32_9 = "1001";
const sc_lv<32> hls_macc::ap_const_lv32_19 = "11001";
const sc_lv<32> hls_macc::ap_const_lv32_1 = "1";
const sc_lv<1> hls_macc::ap_const_lv1_0 = "0";
const sc_lv<32> hls_macc::ap_const_lv32_2 = "10";
const sc_lv<32> hls_macc::ap_const_lv32_2B = "101011";
const sc_lv<32> hls_macc::ap_const_lv32_3B = "111011";
const sc_lv<64> hls_macc::ap_const_lv64_0 = "0000000000000000000000000000000000000000000000000000000000000000";
const sc_lv<7> hls_macc::ap_const_lv7_1 = "1";
const sc_lv<1> hls_macc::ap_const_lv1_1 = "1";
const sc_lv<32> hls_macc::ap_const_lv32_A = "1010";
const sc_lv<32> hls_macc::ap_const_lv32_2C = "101100";
const sc_lv<32> hls_macc::ap_const_lv32_1A = "11010";
const sc_lv<32> hls_macc::ap_const_lv32_12 = "10010";
const sc_lv<7> hls_macc::ap_const_lv7_65 = "1100101";
const sc_lv<2> hls_macc::ap_const_lv2_0 = "00";
const sc_lv<2> hls_macc::ap_const_lv2_1 = "1";
const bool hls_macc::ap_const_boolean_1 = true;

hls_macc::hls_macc(sc_module_name name) : sc_module(name), mVcdFile(0) {
    hls_macc_HLS_MACC_PERIPH_BUS_s_axi_U = new hls_macc_HLS_MACC_PERIPH_BUS_s_axi<C_S_AXI_HLS_MACC_PERIPH_BUS_ADDR_WIDTH,C_S_AXI_HLS_MACC_PERIPH_BUS_DATA_WIDTH>("hls_macc_HLS_MACC_PERIPH_BUS_s_axi_U");
    hls_macc_HLS_MACC_PERIPH_BUS_s_axi_U->AWVALID(s_axi_HLS_MACC_PERIPH_BUS_AWVALID);
    hls_macc_HLS_MACC_PERIPH_BUS_s_axi_U->AWREADY(s_axi_HLS_MACC_PERIPH_BUS_AWREADY);
    hls_macc_HLS_MACC_PERIPH_BUS_s_axi_U->AWADDR(s_axi_HLS_MACC_PERIPH_BUS_AWADDR);
    hls_macc_HLS_MACC_PERIPH_BUS_s_axi_U->WVALID(s_axi_HLS_MACC_PERIPH_BUS_WVALID);
    hls_macc_HLS_MACC_PERIPH_BUS_s_axi_U->WREADY(s_axi_HLS_MACC_PERIPH_BUS_WREADY);
    hls_macc_HLS_MACC_PERIPH_BUS_s_axi_U->WDATA(s_axi_HLS_MACC_PERIPH_BUS_WDATA);
    hls_macc_HLS_MACC_PERIPH_BUS_s_axi_U->WSTRB(s_axi_HLS_MACC_PERIPH_BUS_WSTRB);
    hls_macc_HLS_MACC_PERIPH_BUS_s_axi_U->ARVALID(s_axi_HLS_MACC_PERIPH_BUS_ARVALID);
    hls_macc_HLS_MACC_PERIPH_BUS_s_axi_U->ARREADY(s_axi_HLS_MACC_PERIPH_BUS_ARREADY);
    hls_macc_HLS_MACC_PERIPH_BUS_s_axi_U->ARADDR(s_axi_HLS_MACC_PERIPH_BUS_ARADDR);
    hls_macc_HLS_MACC_PERIPH_BUS_s_axi_U->RVALID(s_axi_HLS_MACC_PERIPH_BUS_RVALID);
    hls_macc_HLS_MACC_PERIPH_BUS_s_axi_U->RREADY(s_axi_HLS_MACC_PERIPH_BUS_RREADY);
    hls_macc_HLS_MACC_PERIPH_BUS_s_axi_U->RDATA(s_axi_HLS_MACC_PERIPH_BUS_RDATA);
    hls_macc_HLS_MACC_PERIPH_BUS_s_axi_U->RRESP(s_axi_HLS_MACC_PERIPH_BUS_RRESP);
    hls_macc_HLS_MACC_PERIPH_BUS_s_axi_U->BVALID(s_axi_HLS_MACC_PERIPH_BUS_BVALID);
    hls_macc_HLS_MACC_PERIPH_BUS_s_axi_U->BREADY(s_axi_HLS_MACC_PERIPH_BUS_BREADY);
    hls_macc_HLS_MACC_PERIPH_BUS_s_axi_U->BRESP(s_axi_HLS_MACC_PERIPH_BUS_BRESP);
    hls_macc_HLS_MACC_PERIPH_BUS_s_axi_U->ACLK(ap_clk);
    hls_macc_HLS_MACC_PERIPH_BUS_s_axi_U->ARESET(ap_rst_n_inv);
    hls_macc_HLS_MACC_PERIPH_BUS_s_axi_U->ACLK_EN(ap_var_for_const0);
    hls_macc_HLS_MACC_PERIPH_BUS_s_axi_U->ap_start(ap_start);
    hls_macc_HLS_MACC_PERIPH_BUS_s_axi_U->interrupt(interrupt);
    hls_macc_HLS_MACC_PERIPH_BUS_s_axi_U->ap_ready(ap_ready);
    hls_macc_HLS_MACC_PERIPH_BUS_s_axi_U->ap_done(ap_done);
    hls_macc_HLS_MACC_PERIPH_BUS_s_axi_U->ap_idle(ap_idle);
    hls_macc_HLS_MACC_PERIPH_BUS_s_axi_U->x(x);
    hls_macc_HLS_MACC_PERIPH_BUS_s_axi_U->y(s_0_reg_51);
    hls_macc_HLS_MACC_PERIPH_BUS_s_axi_U->y_ap_vld(y_ap_vld);
    hls_macc_dadddsub_64ns_64ns_64_16_full_dsp_1_U1 = new hls_macc_dadddsub_64ns_64ns_64_16_full_dsp_1<1,16,64,64,64>("hls_macc_dadddsub_64ns_64ns_64_16_full_dsp_1_U1");
    hls_macc_dadddsub_64ns_64ns_64_16_full_dsp_1_U1->clk(ap_clk);
    hls_macc_dadddsub_64ns_64ns_64_16_full_dsp_1_U1->reset(ap_rst_n_inv);
    hls_macc_dadddsub_64ns_64ns_64_16_full_dsp_1_U1->din0(grp_fu_75_p0);
    hls_macc_dadddsub_64ns_64ns_64_16_full_dsp_1_U1->din1(grp_fu_75_p1);
    hls_macc_dadddsub_64ns_64ns_64_16_full_dsp_1_U1->opcode(grp_fu_75_opcode);
    hls_macc_dadddsub_64ns_64ns_64_16_full_dsp_1_U1->ce(ap_var_for_const0);
    hls_macc_dadddsub_64ns_64ns_64_16_full_dsp_1_U1->dout(grp_fu_75_p2);
    hls_macc_dmul_64ns_64ns_64_18_max_dsp_1_U2 = new hls_macc_dmul_64ns_64ns_64_18_max_dsp_1<1,18,64,64,64>("hls_macc_dmul_64ns_64ns_64_18_max_dsp_1_U2");
    hls_macc_dmul_64ns_64ns_64_18_max_dsp_1_U2->clk(ap_clk);
    hls_macc_dmul_64ns_64ns_64_18_max_dsp_1_U2->reset(ap_rst_n_inv);
    hls_macc_dmul_64ns_64ns_64_18_max_dsp_1_U2->din0(reg_87);
    hls_macc_dmul_64ns_64ns_64_18_max_dsp_1_U2->din1(tmp_2_reg_159);
    hls_macc_dmul_64ns_64ns_64_18_max_dsp_1_U2->ce(ap_var_for_const0);
    hls_macc_dmul_64ns_64ns_64_18_max_dsp_1_U2->dout(grp_fu_80_p2);
    hls_macc_sitodp_32ns_64_8_1_U3 = new hls_macc_sitodp_32ns_64_8_1<1,8,32,64>("hls_macc_sitodp_32ns_64_8_1_U3");
    hls_macc_sitodp_32ns_64_8_1_U3->clk(ap_clk);
    hls_macc_sitodp_32ns_64_8_1_U3->reset(ap_rst_n_inv);
    hls_macc_sitodp_32ns_64_8_1_U3->din0(grp_fu_84_p0);
    hls_macc_sitodp_32ns_64_8_1_U3->ce(ap_var_for_const0);
    hls_macc_sitodp_32ns_64_8_1_U3->dout(grp_fu_84_p1);

    SC_METHOD(thread_ap_clk_no_reset_);
    dont_initialize();
    sensitive << ( ap_clk.pos() );

    SC_METHOD(thread_add_ln11_fu_115_p2);
    sensitive << ( zext_ln10_fu_93_p1 );
    sensitive << ( shl_ln_fu_107_p3 );

    SC_METHOD(thread_ap_CS_fsm_state1);
    sensitive << ( ap_CS_fsm );

    SC_METHOD(thread_ap_CS_fsm_state10);
    sensitive << ( ap_CS_fsm );

    SC_METHOD(thread_ap_CS_fsm_state11);
    sensitive << ( ap_CS_fsm );

    SC_METHOD(thread_ap_CS_fsm_state19);
    sensitive << ( ap_CS_fsm );

    SC_METHOD(thread_ap_CS_fsm_state2);
    sensitive << ( ap_CS_fsm );

    SC_METHOD(thread_ap_CS_fsm_state26);
    sensitive << ( ap_CS_fsm );

    SC_METHOD(thread_ap_CS_fsm_state27);
    sensitive << ( ap_CS_fsm );

    SC_METHOD(thread_ap_CS_fsm_state3);
    sensitive << ( ap_CS_fsm );

    SC_METHOD(thread_ap_CS_fsm_state44);
    sensitive << ( ap_CS_fsm );

    SC_METHOD(thread_ap_CS_fsm_state45);
    sensitive << ( ap_CS_fsm );

    SC_METHOD(thread_ap_CS_fsm_state60);
    sensitive << ( ap_CS_fsm );

    SC_METHOD(thread_ap_done);
    sensitive << ( ap_CS_fsm_state2 );
    sensitive << ( icmp_ln10_fu_101_p2 );

    SC_METHOD(thread_ap_idle);
    sensitive << ( ap_start );
    sensitive << ( ap_CS_fsm_state1 );

    SC_METHOD(thread_ap_ready);
    sensitive << ( ap_CS_fsm_state2 );
    sensitive << ( icmp_ln10_fu_101_p2 );

    SC_METHOD(thread_ap_rst_n_inv);
    sensitive << ( ap_rst_n );

    SC_METHOD(thread_grp_fu_75_opcode);
    sensitive << ( ap_CS_fsm_state11 );
    sensitive << ( ap_CS_fsm_state45 );

    SC_METHOD(thread_grp_fu_75_p0);
    sensitive << ( x_read_reg_131 );
    sensitive << ( s_0_reg_51 );
    sensitive << ( ap_CS_fsm_state11 );
    sensitive << ( ap_CS_fsm_state45 );

    SC_METHOD(thread_grp_fu_75_p1);
    sensitive << ( reg_87 );
    sensitive << ( tmp_3_reg_164 );
    sensitive << ( ap_CS_fsm_state11 );
    sensitive << ( ap_CS_fsm_state45 );

    SC_METHOD(thread_grp_fu_84_p0);
    sensitive << ( zext_ln10_1_reg_136 );
    sensitive << ( zext_ln11_fu_127_p1 );
    sensitive << ( ap_CS_fsm_state3 );
    sensitive << ( ap_CS_fsm_state19 );

    SC_METHOD(thread_i_fu_121_p2);
    sensitive << ( i_0_reg_64 );

    SC_METHOD(thread_icmp_ln10_fu_101_p2);
    sensitive << ( ap_CS_fsm_state2 );
    sensitive << ( i_0_reg_64 );

    SC_METHOD(thread_shl_ln_fu_107_p3);
    sensitive << ( i_0_reg_64 );

    SC_METHOD(thread_y_ap_vld);
    sensitive << ( ap_CS_fsm_state2 );
    sensitive << ( icmp_ln10_fu_101_p2 );

    SC_METHOD(thread_zext_ln10_1_fu_97_p1);
    sensitive << ( i_0_reg_64 );

    SC_METHOD(thread_zext_ln10_fu_93_p1);
    sensitive << ( i_0_reg_64 );

    SC_METHOD(thread_zext_ln11_fu_127_p1);
    sensitive << ( add_ln11_reg_144 );

    SC_METHOD(thread_ap_NS_fsm);
    sensitive << ( ap_start );
    sensitive << ( ap_CS_fsm );
    sensitive << ( ap_CS_fsm_state1 );
    sensitive << ( ap_CS_fsm_state2 );
    sensitive << ( icmp_ln10_fu_101_p2 );

    SC_THREAD(thread_hdltv_gen);
    sensitive << ( ap_clk.pos() );

    SC_THREAD(thread_ap_var_for_const0);

    ap_CS_fsm = "000000000000000000000000000000000000000000000000000000000001";
    static int apTFileNum = 0;
    stringstream apTFilenSS;
    apTFilenSS << "hls_macc_sc_trace_" << apTFileNum ++;
    string apTFn = apTFilenSS.str();
    mVcdFile = sc_create_vcd_trace_file(apTFn.c_str());
    mVcdFile->set_time_unit(1, SC_PS);
    if (1) {
#ifdef __HLS_TRACE_LEVEL_PORT__
    sc_trace(mVcdFile, ap_clk, "(port)ap_clk");
    sc_trace(mVcdFile, ap_rst_n, "(port)ap_rst_n");
    sc_trace(mVcdFile, s_axi_HLS_MACC_PERIPH_BUS_AWVALID, "(port)s_axi_HLS_MACC_PERIPH_BUS_AWVALID");
    sc_trace(mVcdFile, s_axi_HLS_MACC_PERIPH_BUS_AWREADY, "(port)s_axi_HLS_MACC_PERIPH_BUS_AWREADY");
    sc_trace(mVcdFile, s_axi_HLS_MACC_PERIPH_BUS_AWADDR, "(port)s_axi_HLS_MACC_PERIPH_BUS_AWADDR");
    sc_trace(mVcdFile, s_axi_HLS_MACC_PERIPH_BUS_WVALID, "(port)s_axi_HLS_MACC_PERIPH_BUS_WVALID");
    sc_trace(mVcdFile, s_axi_HLS_MACC_PERIPH_BUS_WREADY, "(port)s_axi_HLS_MACC_PERIPH_BUS_WREADY");
    sc_trace(mVcdFile, s_axi_HLS_MACC_PERIPH_BUS_WDATA, "(port)s_axi_HLS_MACC_PERIPH_BUS_WDATA");
    sc_trace(mVcdFile, s_axi_HLS_MACC_PERIPH_BUS_WSTRB, "(port)s_axi_HLS_MACC_PERIPH_BUS_WSTRB");
    sc_trace(mVcdFile, s_axi_HLS_MACC_PERIPH_BUS_ARVALID, "(port)s_axi_HLS_MACC_PERIPH_BUS_ARVALID");
    sc_trace(mVcdFile, s_axi_HLS_MACC_PERIPH_BUS_ARREADY, "(port)s_axi_HLS_MACC_PERIPH_BUS_ARREADY");
    sc_trace(mVcdFile, s_axi_HLS_MACC_PERIPH_BUS_ARADDR, "(port)s_axi_HLS_MACC_PERIPH_BUS_ARADDR");
    sc_trace(mVcdFile, s_axi_HLS_MACC_PERIPH_BUS_RVALID, "(port)s_axi_HLS_MACC_PERIPH_BUS_RVALID");
    sc_trace(mVcdFile, s_axi_HLS_MACC_PERIPH_BUS_RREADY, "(port)s_axi_HLS_MACC_PERIPH_BUS_RREADY");
    sc_trace(mVcdFile, s_axi_HLS_MACC_PERIPH_BUS_RDATA, "(port)s_axi_HLS_MACC_PERIPH_BUS_RDATA");
    sc_trace(mVcdFile, s_axi_HLS_MACC_PERIPH_BUS_RRESP, "(port)s_axi_HLS_MACC_PERIPH_BUS_RRESP");
    sc_trace(mVcdFile, s_axi_HLS_MACC_PERIPH_BUS_BVALID, "(port)s_axi_HLS_MACC_PERIPH_BUS_BVALID");
    sc_trace(mVcdFile, s_axi_HLS_MACC_PERIPH_BUS_BREADY, "(port)s_axi_HLS_MACC_PERIPH_BUS_BREADY");
    sc_trace(mVcdFile, s_axi_HLS_MACC_PERIPH_BUS_BRESP, "(port)s_axi_HLS_MACC_PERIPH_BUS_BRESP");
    sc_trace(mVcdFile, interrupt, "(port)interrupt");
#endif
#ifdef __HLS_TRACE_LEVEL_INT__
    sc_trace(mVcdFile, ap_rst_n_inv, "ap_rst_n_inv");
    sc_trace(mVcdFile, ap_start, "ap_start");
    sc_trace(mVcdFile, ap_done, "ap_done");
    sc_trace(mVcdFile, ap_idle, "ap_idle");
    sc_trace(mVcdFile, ap_CS_fsm, "ap_CS_fsm");
    sc_trace(mVcdFile, ap_CS_fsm_state1, "ap_CS_fsm_state1");
    sc_trace(mVcdFile, ap_ready, "ap_ready");
    sc_trace(mVcdFile, x, "x");
    sc_trace(mVcdFile, y_ap_vld, "y_ap_vld");
    sc_trace(mVcdFile, grp_fu_84_p1, "grp_fu_84_p1");
    sc_trace(mVcdFile, reg_87, "reg_87");
    sc_trace(mVcdFile, ap_CS_fsm_state10, "ap_CS_fsm_state10");
    sc_trace(mVcdFile, ap_CS_fsm_state26, "ap_CS_fsm_state26");
    sc_trace(mVcdFile, x_read_reg_131, "x_read_reg_131");
    sc_trace(mVcdFile, zext_ln10_1_fu_97_p1, "zext_ln10_1_fu_97_p1");
    sc_trace(mVcdFile, zext_ln10_1_reg_136, "zext_ln10_1_reg_136");
    sc_trace(mVcdFile, ap_CS_fsm_state2, "ap_CS_fsm_state2");
    sc_trace(mVcdFile, add_ln11_fu_115_p2, "add_ln11_fu_115_p2");
    sc_trace(mVcdFile, add_ln11_reg_144, "add_ln11_reg_144");
    sc_trace(mVcdFile, icmp_ln10_fu_101_p2, "icmp_ln10_fu_101_p2");
    sc_trace(mVcdFile, i_fu_121_p2, "i_fu_121_p2");
    sc_trace(mVcdFile, i_reg_149, "i_reg_149");
    sc_trace(mVcdFile, zext_ln11_fu_127_p1, "zext_ln11_fu_127_p1");
    sc_trace(mVcdFile, ap_CS_fsm_state3, "ap_CS_fsm_state3");
    sc_trace(mVcdFile, grp_fu_75_p2, "grp_fu_75_p2");
    sc_trace(mVcdFile, tmp_2_reg_159, "tmp_2_reg_159");
    sc_trace(mVcdFile, grp_fu_80_p2, "grp_fu_80_p2");
    sc_trace(mVcdFile, tmp_3_reg_164, "tmp_3_reg_164");
    sc_trace(mVcdFile, ap_CS_fsm_state44, "ap_CS_fsm_state44");
    sc_trace(mVcdFile, ap_CS_fsm_state60, "ap_CS_fsm_state60");
    sc_trace(mVcdFile, s_0_reg_51, "s_0_reg_51");
    sc_trace(mVcdFile, i_0_reg_64, "i_0_reg_64");
    sc_trace(mVcdFile, grp_fu_75_p0, "grp_fu_75_p0");
    sc_trace(mVcdFile, grp_fu_75_p1, "grp_fu_75_p1");
    sc_trace(mVcdFile, ap_CS_fsm_state11, "ap_CS_fsm_state11");
    sc_trace(mVcdFile, ap_CS_fsm_state45, "ap_CS_fsm_state45");
    sc_trace(mVcdFile, ap_CS_fsm_state27, "ap_CS_fsm_state27");
    sc_trace(mVcdFile, grp_fu_84_p0, "grp_fu_84_p0");
    sc_trace(mVcdFile, ap_CS_fsm_state19, "ap_CS_fsm_state19");
    sc_trace(mVcdFile, zext_ln10_fu_93_p1, "zext_ln10_fu_93_p1");
    sc_trace(mVcdFile, shl_ln_fu_107_p3, "shl_ln_fu_107_p3");
    sc_trace(mVcdFile, grp_fu_75_opcode, "grp_fu_75_opcode");
    sc_trace(mVcdFile, ap_NS_fsm, "ap_NS_fsm");
#endif

    }
    mHdltvinHandle.open("hls_macc.hdltvin.dat");
    mHdltvoutHandle.open("hls_macc.hdltvout.dat");
}

hls_macc::~hls_macc() {
    if (mVcdFile) 
        sc_close_vcd_trace_file(mVcdFile);

    mHdltvinHandle << "] " << endl;
    mHdltvoutHandle << "] " << endl;
    mHdltvinHandle.close();
    mHdltvoutHandle.close();
    delete hls_macc_HLS_MACC_PERIPH_BUS_s_axi_U;
    delete hls_macc_dadddsub_64ns_64ns_64_16_full_dsp_1_U1;
    delete hls_macc_dmul_64ns_64ns_64_18_max_dsp_1_U2;
    delete hls_macc_sitodp_32ns_64_8_1_U3;
}

void hls_macc::thread_ap_var_for_const0() {
    ap_var_for_const0 = ap_const_logic_1;
}

void hls_macc::thread_ap_clk_no_reset_() {
    if ( ap_rst_n_inv.read() == ap_const_logic_1) {
        ap_CS_fsm = ap_ST_fsm_state1;
    } else {
        ap_CS_fsm = ap_NS_fsm.read();
    }
    if (esl_seteq<1,1,1>(ap_const_logic_1, ap_CS_fsm_state60.read())) {
        i_0_reg_64 = i_reg_149.read();
    } else if ((esl_seteq<1,1,1>(ap_const_logic_1, ap_CS_fsm_state1.read()) && 
                esl_seteq<1,1,1>(ap_start.read(), ap_const_logic_1))) {
        i_0_reg_64 = ap_const_lv7_1;
    }
    if (esl_seteq<1,1,1>(ap_const_logic_1, ap_CS_fsm_state60.read())) {
        s_0_reg_51 = grp_fu_75_p2.read();
    } else if ((esl_seteq<1,1,1>(ap_const_logic_1, ap_CS_fsm_state1.read()) && 
                esl_seteq<1,1,1>(ap_start.read(), ap_const_logic_1))) {
        s_0_reg_51 = ap_const_lv64_0;
    }
    if ((esl_seteq<1,1,1>(ap_const_logic_1, ap_CS_fsm_state2.read()) && esl_seteq<1,1,1>(icmp_ln10_fu_101_p2.read(), ap_const_lv1_0))) {
        add_ln11_reg_144 = add_ln11_fu_115_p2.read();
        i_reg_149 = i_fu_121_p2.read();
    }
    if ((esl_seteq<1,1,1>(ap_const_logic_1, ap_CS_fsm_state10.read()) || esl_seteq<1,1,1>(ap_const_logic_1, ap_CS_fsm_state26.read()))) {
        reg_87 = grp_fu_84_p1.read();
    }
    if (esl_seteq<1,1,1>(ap_const_logic_1, ap_CS_fsm_state26.read())) {
        tmp_2_reg_159 = grp_fu_75_p2.read();
    }
    if (esl_seteq<1,1,1>(ap_const_logic_1, ap_CS_fsm_state44.read())) {
        tmp_3_reg_164 = grp_fu_80_p2.read();
    }
    if ((esl_seteq<1,1,1>(ap_const_logic_1, ap_CS_fsm_state1.read()) && esl_seteq<1,1,1>(ap_start.read(), ap_const_logic_1))) {
        x_read_reg_131 = x.read();
    }
    if (esl_seteq<1,1,1>(ap_const_logic_1, ap_CS_fsm_state2.read())) {
        zext_ln10_1_reg_136 = zext_ln10_1_fu_97_p1.read();
    }
}

void hls_macc::thread_add_ln11_fu_115_p2() {
    add_ln11_fu_115_p2 = (!zext_ln10_fu_93_p1.read().is_01() || !shl_ln_fu_107_p3.read().is_01())? sc_lv<9>(): (sc_biguint<9>(zext_ln10_fu_93_p1.read()) + sc_biguint<9>(shl_ln_fu_107_p3.read()));
}

void hls_macc::thread_ap_CS_fsm_state1() {
    ap_CS_fsm_state1 = ap_CS_fsm.read()[0];
}

void hls_macc::thread_ap_CS_fsm_state10() {
    ap_CS_fsm_state10 = ap_CS_fsm.read()[9];
}

void hls_macc::thread_ap_CS_fsm_state11() {
    ap_CS_fsm_state11 = ap_CS_fsm.read()[10];
}

void hls_macc::thread_ap_CS_fsm_state19() {
    ap_CS_fsm_state19 = ap_CS_fsm.read()[18];
}

void hls_macc::thread_ap_CS_fsm_state2() {
    ap_CS_fsm_state2 = ap_CS_fsm.read()[1];
}

void hls_macc::thread_ap_CS_fsm_state26() {
    ap_CS_fsm_state26 = ap_CS_fsm.read()[25];
}

void hls_macc::thread_ap_CS_fsm_state27() {
    ap_CS_fsm_state27 = ap_CS_fsm.read()[26];
}

void hls_macc::thread_ap_CS_fsm_state3() {
    ap_CS_fsm_state3 = ap_CS_fsm.read()[2];
}

void hls_macc::thread_ap_CS_fsm_state44() {
    ap_CS_fsm_state44 = ap_CS_fsm.read()[43];
}

void hls_macc::thread_ap_CS_fsm_state45() {
    ap_CS_fsm_state45 = ap_CS_fsm.read()[44];
}

void hls_macc::thread_ap_CS_fsm_state60() {
    ap_CS_fsm_state60 = ap_CS_fsm.read()[59];
}

void hls_macc::thread_ap_done() {
    if ((esl_seteq<1,1,1>(ap_const_logic_1, ap_CS_fsm_state2.read()) && 
         esl_seteq<1,1,1>(icmp_ln10_fu_101_p2.read(), ap_const_lv1_1))) {
        ap_done = ap_const_logic_1;
    } else {
        ap_done = ap_const_logic_0;
    }
}

void hls_macc::thread_ap_idle() {
    if ((esl_seteq<1,1,1>(ap_const_logic_0, ap_start.read()) && 
         esl_seteq<1,1,1>(ap_const_logic_1, ap_CS_fsm_state1.read()))) {
        ap_idle = ap_const_logic_1;
    } else {
        ap_idle = ap_const_logic_0;
    }
}

void hls_macc::thread_ap_ready() {
    if ((esl_seteq<1,1,1>(ap_const_logic_1, ap_CS_fsm_state2.read()) && 
         esl_seteq<1,1,1>(icmp_ln10_fu_101_p2.read(), ap_const_lv1_1))) {
        ap_ready = ap_const_logic_1;
    } else {
        ap_ready = ap_const_logic_0;
    }
}

void hls_macc::thread_ap_rst_n_inv() {
    ap_rst_n_inv =  (sc_logic) (~ap_rst_n.read());
}

void hls_macc::thread_grp_fu_75_opcode() {
    if (esl_seteq<1,1,1>(ap_const_logic_1, ap_CS_fsm_state11.read())) {
        grp_fu_75_opcode = ap_const_lv2_1;
    } else if (esl_seteq<1,1,1>(ap_const_logic_1, ap_CS_fsm_state45.read())) {
        grp_fu_75_opcode = ap_const_lv2_0;
    } else {
        grp_fu_75_opcode = "XX";
    }
}

void hls_macc::thread_grp_fu_75_p0() {
    if (esl_seteq<1,1,1>(ap_const_logic_1, ap_CS_fsm_state45.read())) {
        grp_fu_75_p0 = s_0_reg_51.read();
    } else if (esl_seteq<1,1,1>(ap_const_logic_1, ap_CS_fsm_state11.read())) {
        grp_fu_75_p0 = x_read_reg_131.read();
    } else {
        grp_fu_75_p0 =  (sc_lv<64>) ("XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX");
    }
}

void hls_macc::thread_grp_fu_75_p1() {
    if (esl_seteq<1,1,1>(ap_const_logic_1, ap_CS_fsm_state45.read())) {
        grp_fu_75_p1 = tmp_3_reg_164.read();
    } else if (esl_seteq<1,1,1>(ap_const_logic_1, ap_CS_fsm_state11.read())) {
        grp_fu_75_p1 = reg_87.read();
    } else {
        grp_fu_75_p1 =  (sc_lv<64>) ("XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX");
    }
}

void hls_macc::thread_grp_fu_84_p0() {
    if (esl_seteq<1,1,1>(ap_const_logic_1, ap_CS_fsm_state19.read())) {
        grp_fu_84_p0 = zext_ln10_1_reg_136.read();
    } else if (esl_seteq<1,1,1>(ap_const_logic_1, ap_CS_fsm_state3.read())) {
        grp_fu_84_p0 = zext_ln11_fu_127_p1.read();
    } else {
        grp_fu_84_p0 =  (sc_lv<32>) ("XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX");
    }
}

void hls_macc::thread_i_fu_121_p2() {
    i_fu_121_p2 = (!i_0_reg_64.read().is_01() || !ap_const_lv7_1.is_01())? sc_lv<7>(): (sc_biguint<7>(i_0_reg_64.read()) + sc_biguint<7>(ap_const_lv7_1));
}

void hls_macc::thread_icmp_ln10_fu_101_p2() {
    icmp_ln10_fu_101_p2 = (!i_0_reg_64.read().is_01() || !ap_const_lv7_65.is_01())? sc_lv<1>(): sc_lv<1>(i_0_reg_64.read() == ap_const_lv7_65);
}

void hls_macc::thread_shl_ln_fu_107_p3() {
    shl_ln_fu_107_p3 = esl_concat<7,2>(i_0_reg_64.read(), ap_const_lv2_0);
}

void hls_macc::thread_y_ap_vld() {
    if ((esl_seteq<1,1,1>(ap_const_logic_1, ap_CS_fsm_state2.read()) && 
         esl_seteq<1,1,1>(icmp_ln10_fu_101_p2.read(), ap_const_lv1_1))) {
        y_ap_vld = ap_const_logic_1;
    } else {
        y_ap_vld = ap_const_logic_0;
    }
}

void hls_macc::thread_zext_ln10_1_fu_97_p1() {
    zext_ln10_1_fu_97_p1 = esl_zext<32,7>(i_0_reg_64.read());
}

void hls_macc::thread_zext_ln10_fu_93_p1() {
    zext_ln10_fu_93_p1 = esl_zext<9,7>(i_0_reg_64.read());
}

void hls_macc::thread_zext_ln11_fu_127_p1() {
    zext_ln11_fu_127_p1 = esl_zext<32,9>(add_ln11_reg_144.read());
}

void hls_macc::thread_ap_NS_fsm() {
    switch (ap_CS_fsm.read().to_uint64()) {
        case 1 : 
            if ((esl_seteq<1,1,1>(ap_const_logic_1, ap_CS_fsm_state1.read()) && esl_seteq<1,1,1>(ap_start.read(), ap_const_logic_1))) {
                ap_NS_fsm = ap_ST_fsm_state2;
            } else {
                ap_NS_fsm = ap_ST_fsm_state1;
            }
            break;
        case 2 : 
            if ((esl_seteq<1,1,1>(ap_const_logic_1, ap_CS_fsm_state2.read()) && esl_seteq<1,1,1>(icmp_ln10_fu_101_p2.read(), ap_const_lv1_1))) {
                ap_NS_fsm = ap_ST_fsm_state1;
            } else {
                ap_NS_fsm = ap_ST_fsm_state3;
            }
            break;
        case 4 : 
            ap_NS_fsm = ap_ST_fsm_state4;
            break;
        case 8 : 
            ap_NS_fsm = ap_ST_fsm_state5;
            break;
        case 16 : 
            ap_NS_fsm = ap_ST_fsm_state6;
            break;
        case 32 : 
            ap_NS_fsm = ap_ST_fsm_state7;
            break;
        case 64 : 
            ap_NS_fsm = ap_ST_fsm_state8;
            break;
        case 128 : 
            ap_NS_fsm = ap_ST_fsm_state9;
            break;
        case 256 : 
            ap_NS_fsm = ap_ST_fsm_state10;
            break;
        case 512 : 
            ap_NS_fsm = ap_ST_fsm_state11;
            break;
        case 1024 : 
            ap_NS_fsm = ap_ST_fsm_state12;
            break;
        case 2048 : 
            ap_NS_fsm = ap_ST_fsm_state13;
            break;
        case 4096 : 
            ap_NS_fsm = ap_ST_fsm_state14;
            break;
        case 8192 : 
            ap_NS_fsm = ap_ST_fsm_state15;
            break;
        case 16384 : 
            ap_NS_fsm = ap_ST_fsm_state16;
            break;
        case 32768 : 
            ap_NS_fsm = ap_ST_fsm_state17;
            break;
        case 65536 : 
            ap_NS_fsm = ap_ST_fsm_state18;
            break;
        case 131072 : 
            ap_NS_fsm = ap_ST_fsm_state19;
            break;
        case 262144 : 
            ap_NS_fsm = ap_ST_fsm_state20;
            break;
        case 524288 : 
            ap_NS_fsm = ap_ST_fsm_state21;
            break;
        case 1048576 : 
            ap_NS_fsm = ap_ST_fsm_state22;
            break;
        case 2097152 : 
            ap_NS_fsm = ap_ST_fsm_state23;
            break;
        case 4194304 : 
            ap_NS_fsm = ap_ST_fsm_state24;
            break;
        case 8388608 : 
            ap_NS_fsm = ap_ST_fsm_state25;
            break;
        case 16777216 : 
            ap_NS_fsm = ap_ST_fsm_state26;
            break;
        case 33554432 : 
            ap_NS_fsm = ap_ST_fsm_state27;
            break;
        case 67108864 : 
            ap_NS_fsm = ap_ST_fsm_state28;
            break;
        case 134217728 : 
            ap_NS_fsm = ap_ST_fsm_state29;
            break;
        case 268435456 : 
            ap_NS_fsm = ap_ST_fsm_state30;
            break;
        case 536870912 : 
            ap_NS_fsm = ap_ST_fsm_state31;
            break;
        case 1073741824 : 
            ap_NS_fsm = ap_ST_fsm_state32;
            break;
        case 2147483648 : 
            ap_NS_fsm = ap_ST_fsm_state33;
            break;
        case 4294967296 : 
            ap_NS_fsm = ap_ST_fsm_state34;
            break;
        case 8589934592 : 
            ap_NS_fsm = ap_ST_fsm_state35;
            break;
        case 17179869184 : 
            ap_NS_fsm = ap_ST_fsm_state36;
            break;
        case 34359738368 : 
            ap_NS_fsm = ap_ST_fsm_state37;
            break;
        case 68719476736 : 
            ap_NS_fsm = ap_ST_fsm_state38;
            break;
        case 137438953472 : 
            ap_NS_fsm = ap_ST_fsm_state39;
            break;
        case 274877906944 : 
            ap_NS_fsm = ap_ST_fsm_state40;
            break;
        case 549755813888 : 
            ap_NS_fsm = ap_ST_fsm_state41;
            break;
        case 1099511627776 : 
            ap_NS_fsm = ap_ST_fsm_state42;
            break;
        case 2199023255552 : 
            ap_NS_fsm = ap_ST_fsm_state43;
            break;
        case 4398046511104 : 
            ap_NS_fsm = ap_ST_fsm_state44;
            break;
        case 8796093022208 : 
            ap_NS_fsm = ap_ST_fsm_state45;
            break;
        case 17592186044416 : 
            ap_NS_fsm = ap_ST_fsm_state46;
            break;
        case 35184372088832 : 
            ap_NS_fsm = ap_ST_fsm_state47;
            break;
        case 70368744177664 : 
            ap_NS_fsm = ap_ST_fsm_state48;
            break;
        case 140737488355328 : 
            ap_NS_fsm = ap_ST_fsm_state49;
            break;
        case 281474976710656 : 
            ap_NS_fsm = ap_ST_fsm_state50;
            break;
        case 562949953421312 : 
            ap_NS_fsm = ap_ST_fsm_state51;
            break;
        case 1125899906842624 : 
            ap_NS_fsm = ap_ST_fsm_state52;
            break;
        case 2251799813685248 : 
            ap_NS_fsm = ap_ST_fsm_state53;
            break;
        case 4503599627370496 : 
            ap_NS_fsm = ap_ST_fsm_state54;
            break;
        case 9007199254740992 : 
            ap_NS_fsm = ap_ST_fsm_state55;
            break;
        case 18014398509481984 : 
            ap_NS_fsm = ap_ST_fsm_state56;
            break;
        case 36028797018963968 : 
            ap_NS_fsm = ap_ST_fsm_state57;
            break;
        case 72057594037927936 : 
            ap_NS_fsm = ap_ST_fsm_state58;
            break;
        case 144115188075855872 : 
            ap_NS_fsm = ap_ST_fsm_state59;
            break;
        case 288230376151711744 : 
            ap_NS_fsm = ap_ST_fsm_state60;
            break;
        case 576460752303423488 : 
            ap_NS_fsm = ap_ST_fsm_state2;
            break;
        default : 
            ap_NS_fsm =  (sc_lv<60>) ("XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX");
            break;
    }
}

void hls_macc::thread_hdltv_gen() {
    const char* dump_tv = std::getenv("AP_WRITE_TV");
    if (!(dump_tv && string(dump_tv) == "on")) return;

    wait();

    mHdltvinHandle << "[ " << endl;
    mHdltvoutHandle << "[ " << endl;
    int ap_cycleNo = 0;
    while (1) {
        wait();
        const char* mComma = ap_cycleNo == 0 ? " " : ", " ;
        mHdltvinHandle << mComma << "{"  <<  " \"ap_rst_n\" :  \"" << ap_rst_n.read() << "\" ";
        mHdltvinHandle << " , " <<  " \"s_axi_HLS_MACC_PERIPH_BUS_AWVALID\" :  \"" << s_axi_HLS_MACC_PERIPH_BUS_AWVALID.read() << "\" ";
        mHdltvoutHandle << mComma << "{"  <<  " \"s_axi_HLS_MACC_PERIPH_BUS_AWREADY\" :  \"" << s_axi_HLS_MACC_PERIPH_BUS_AWREADY.read() << "\" ";
        mHdltvinHandle << " , " <<  " \"s_axi_HLS_MACC_PERIPH_BUS_AWADDR\" :  \"" << s_axi_HLS_MACC_PERIPH_BUS_AWADDR.read() << "\" ";
        mHdltvinHandle << " , " <<  " \"s_axi_HLS_MACC_PERIPH_BUS_WVALID\" :  \"" << s_axi_HLS_MACC_PERIPH_BUS_WVALID.read() << "\" ";
        mHdltvoutHandle << " , " <<  " \"s_axi_HLS_MACC_PERIPH_BUS_WREADY\" :  \"" << s_axi_HLS_MACC_PERIPH_BUS_WREADY.read() << "\" ";
        mHdltvinHandle << " , " <<  " \"s_axi_HLS_MACC_PERIPH_BUS_WDATA\" :  \"" << s_axi_HLS_MACC_PERIPH_BUS_WDATA.read() << "\" ";
        mHdltvinHandle << " , " <<  " \"s_axi_HLS_MACC_PERIPH_BUS_WSTRB\" :  \"" << s_axi_HLS_MACC_PERIPH_BUS_WSTRB.read() << "\" ";
        mHdltvinHandle << " , " <<  " \"s_axi_HLS_MACC_PERIPH_BUS_ARVALID\" :  \"" << s_axi_HLS_MACC_PERIPH_BUS_ARVALID.read() << "\" ";
        mHdltvoutHandle << " , " <<  " \"s_axi_HLS_MACC_PERIPH_BUS_ARREADY\" :  \"" << s_axi_HLS_MACC_PERIPH_BUS_ARREADY.read() << "\" ";
        mHdltvinHandle << " , " <<  " \"s_axi_HLS_MACC_PERIPH_BUS_ARADDR\" :  \"" << s_axi_HLS_MACC_PERIPH_BUS_ARADDR.read() << "\" ";
        mHdltvoutHandle << " , " <<  " \"s_axi_HLS_MACC_PERIPH_BUS_RVALID\" :  \"" << s_axi_HLS_MACC_PERIPH_BUS_RVALID.read() << "\" ";
        mHdltvinHandle << " , " <<  " \"s_axi_HLS_MACC_PERIPH_BUS_RREADY\" :  \"" << s_axi_HLS_MACC_PERIPH_BUS_RREADY.read() << "\" ";
        mHdltvoutHandle << " , " <<  " \"s_axi_HLS_MACC_PERIPH_BUS_RDATA\" :  \"" << s_axi_HLS_MACC_PERIPH_BUS_RDATA.read() << "\" ";
        mHdltvoutHandle << " , " <<  " \"s_axi_HLS_MACC_PERIPH_BUS_RRESP\" :  \"" << s_axi_HLS_MACC_PERIPH_BUS_RRESP.read() << "\" ";
        mHdltvoutHandle << " , " <<  " \"s_axi_HLS_MACC_PERIPH_BUS_BVALID\" :  \"" << s_axi_HLS_MACC_PERIPH_BUS_BVALID.read() << "\" ";
        mHdltvinHandle << " , " <<  " \"s_axi_HLS_MACC_PERIPH_BUS_BREADY\" :  \"" << s_axi_HLS_MACC_PERIPH_BUS_BREADY.read() << "\" ";
        mHdltvoutHandle << " , " <<  " \"s_axi_HLS_MACC_PERIPH_BUS_BRESP\" :  \"" << s_axi_HLS_MACC_PERIPH_BUS_BRESP.read() << "\" ";
        mHdltvoutHandle << " , " <<  " \"interrupt\" :  \"" << interrupt.read() << "\" ";
        mHdltvinHandle << "}" << std::endl;
        mHdltvoutHandle << "}" << std::endl;
        ap_cycleNo++;
    }
}

}

